//*******************************************************
//
//  file name: dsm_39khz.c
//
//    DSM(Digital Signal Modurator)ŕϒVAMo͂
//@@
//
//   MPLAB IDE v8.84  HiTEC C
//   
//
//  2021/09/02  New (TAB4) Taishi
//*******************************************************

#include	<htc.h>

#include	"ir_transciever.h"
#include	"dsm_39khz.h"

unsigned short	v_zero_on;				// [nmԁ@irj
unsigned short	v_zero_off;				// [neeԁirj
unsigned short	v_one_on;				// P@nmԁ@irj
unsigned short	v_one_off;				// P@neeԁirj
unsigned short	v_leader_on;			// [_[nmԁ@irj
unsigned short	v_leader_off;			// [_[neeԁirj
unsigned short	v_trailer_on;			// g|[@nmԁ@irj
unsigned short	v_trailer_off;			// g[[@neeԁirj

//*******************************************************
// DSM(Digital Signal Modurator) ̐ݒ@inm^neeL[COj
//*******************************************************
void	init_dsm(void)
{
	//  bboPgɂāAlcahsMi\tgjϒMƂ
	//    o͔]ĂȂA̔guŁ@k̔gbboPiovljȂ̂Ł@
	//    ϒM ̎͂kóAk͕̎ϒMiovljoB
	MDCON  = 0b01000001;		// W[Aso͂͗LAX[[gAo͔]ȂAlcahs͔gggp
	MDSRC  = 0b10000000;		// W[^M̏o̓sFAW[^MFMDBIT
	MDCARH = 0b10000000;		// Ig̏o̓sFAggFVss
	MDCARL = 0b10000100;		// Ig̏o̓sFAkgFCCP1(PWM)


	// 38KHz ̔g`o  26.32uSAFosc/4(8MHz) ŃJEg 210 ɂȂ
	//  ^C}[QJEg^C}[ɂȂ
	T2CON= 0b00000000;			// |XgXP[1:1A܂~AvXP[P
	TMR2    = 0;				// ^C}[l[NAilj
	PR2 = 210;					// 38kHz

	// CCP1 Init.
	CCPR1L = PR2/2;				// 50:50 PWMf[eBig̎ԁj
	CCP1CON = 0b00001100;		// PWM[hVOo
	TMR2ON  = 1;				// ^C}[QX^[g

	MDMSODIS = 0;				// MSD X^[g
}

//*******************************************************
// DSM L
//*******************************************************
void	valid_dsm(void)
{
	MDEN = 1;						// DSM Module Validity
}

//*******************************************************
// DSM 
//*******************************************************
void	invalid_dsm(void)
{
	MDEN = 0;						// DSM Module Invalidity
}

//*******************************************************
// Transmit NEC AEHA DENON Leader Data
//   MDBIT:0 -- 38kHz ON
//   MDBIT:1 -- 38kHz OFF
//*******************************************************
void	tx_nec_aeha_denon_leader(void)
{
	if(v_leader_on != 0){
		MDBIT = 0;				// 38kHz ON
		wait_us(v_leader_on);	// Wait;
	}

	if(v_leader_off != 0){
		MDBIT = 1;				// 38kHz OFF
		wait_us(v_leader_off);	// Wait;
	}
}

//*******************************************************
// Transmit NEC AEHA DENON Trailer Data
//   MDBIT:0 -- 38kHz ON
//   MDBIT:1 -- 38kHz OFF
//*******************************************************
void	tx_nec_aeha_denon_trailer(void)
{
	if(v_trailer_on != 0){
		MDBIT = 0;				// 38kHz ON
		wait_us(v_trailer_on);	// Wait;
	}

	if(v_trailer_off != 0){
		MDBIT = 1;				// 38kHz OFF
		wait_us(v_trailer_off);	// Wait;
	}
}

//*******************************************************
// Transmit NEC AEHA DENON Form 1Byte
//     arg c : Transmit Data(1byte)
//  arg nbit : n of Transmit (bits)
//   MDBIT:0 -- 38kHz ON
//   MDBIT:1 -- 38kHz OFF
//*******************************************************
void	tx_nec_aeha_denon_form_char(unsigned char c, unsigned char nbit)
{
	unsigned char	i;
	unsigned char	b=0x80;
	unsigned char	n;

	if (8 <= nbit){
		n = 8;
	}else{
		n = nbit;
	}


	for(i=0;i<n;i++,b >>= 1){		// Bit7 --> Bit0 Transmit
		MDBIT = 0;					// 38kHz ON
		wait_us(v_zero_on);			// Wait
		MDBIT = 1;					// 38kHz OFF
		if((c & b)==0){				// Bit : 0
			wait_us(v_zero_off);	// Wait
		}else{						// Bit : 1
			wait_us(v_one_off);		// Wait
		}
	}

}

//*******************************************************
// Transmit NEC AEHA DENON format new
//   arg nb1F1'st n of transmit bit
//   arg nb2F2'nd n of transmit bit
//   arg nb3F3'rd n of transmit bit
//   arg 1sFstring pointer
//*******************************************************
void	tx_nec_aeha_denon_form_new_str(unsigned char nb1, unsigned char nb2, unsigned char nb3, char *s)
{
	unsigned char	i;
	unsigned char	n;
	unsigned char	nb;

	nb = nb1;
	n  = (nb1 + 7)/8;

	tx_nec_aeha_denon_leader();					// Transmit Leader Data
	for(i=0;i<n;i++){
		tx_nec_aeha_denon_form_char(*s,nb);		// Transmit 1Byte (nb Bit)
		s++;
		nb -= 8;
	}
	tx_nec_aeha_denon_trailer();				// Transmit Trailer Data


	if(nb2 != 0){
		nb = nb2;
		n  = (nb2 + 7)/8;

		tx_nec_aeha_denon_leader();				// Transmit Leader Data
		for(i=0;i<n;i++){
			tx_nec_aeha_denon_form_char(*s,nb);	// Transmit 1Byte (nb Bit)
			s++;
			nb -= 8;
		}
		tx_nec_aeha_denon_trailer();			// Transmit Trailer Data

	}

	if(nb3 != 0){
		nb = nb3;
		n  = (nb3 + 7)/8;

		tx_nec_aeha_denon_leader();				// Transmit Leader Data
		for(i=0;i<n;i++){
			tx_nec_aeha_denon_form_char(*s,nb);	// Transmit 1Byte (nb Bit)
			s++;
			nb -= 8;
		}
		tx_nec_aeha_denon_trailer();			// Transmit Trailer Data

	}
}

