//*******************************************************
//  PIC 16F1847 ir transciever Program
//  file name: ir_eeprom.c
//
//
//   MPLAB IDE v8.84  HiTEC C
//
//  2021/09/30  New by Taishi ( from PIC16F1936 8x8 Dotmatrix LED Display Program) 
//*******************************************************

#include	<htc.h>

#include	"ir_transciever.h"
#include	"ir_eeprom.h"

// ddoqnl@f[^
	__EEPROM_DATA(0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);		// OOgԒn`
	__EEPROM_DATA(0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);		// OWgԒn`

	__EEPROM_DATA(0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00);		// POgԒn@(DOUSA_REC = 0, DOUSA_TRANS = 1)

	__EEPROM_DATA(0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);		// PWgԒn@Mf[^tH[}bg(NEC_FORMAT = 0, AEHA_FORMAT,  DENON_FORMAT)

	__EEPROM_DATA(0x02,0x0f,0x0f,0x0f,0x16,0x70,0x11,0x8e);		// QOgԒn`@rvPf[^if[^tH[}bg(1)APԖڂ̑Mrbg(1)AQԖڂ̑Mrbg(1)AMf[^(13)@vPUoCgj
	__EEPROM_DATA(0x16,0x70,0x11,0x8e,0x16,0x70,0x00,0x00);		// QWgԒn`  DENON DENON POWER

	__EEPROM_DATA(0x00,0x20,0x00,0x00,0x02,0xfd,0xd8,0x27);		// ROgԒn`@rvQf[^if[^tH[}bg(1)APԖڂ̑Mrbg(1)AQԖڂ̑Mrbg(1)AMf[^(13)@vPUoCgj
	__EEPROM_DATA(0x20,0x62,0x00,0x00,0x00,0x00,0x00,0x00);		// RWgԒn`  NEC TOSHIBA TV POWER

	__EEPROM_DATA(0x01,0x30,0x00,0x00,0x2a,0x4c,0x04,0x40);		// SOgԒn`@rvRf[^if[^tH[}bg(1)APԖڂ̑Mrbg(1)AQԖڂ̑Mrbg(1)AMf[^(13)@vPUoCgj
	__EEPROM_DATA(0xa0,0xe4,0x00,0x00,0x00,0x00,0x00,0x00);		// SWgԒn`  DENON AHEA SOURCE

	__EEPROM_DATA(0x02,0x0f,0x0f,0x0f,0x13,0xd0,0x14,0x2e);		// TOgԒn`@rvSf[^if[^tH[}bg(1)APԖڂ̑Mrbg(1)AQԖڂ̑Mrbg(1)AMf[^(13)@vPUoCgj
	__EEPROM_DATA(0x13,0xd0,0x13,0xd0,0x14,0x2e,0x00,0x00);		// TWgԒn`  DENON DENON STOP

	__EEPROM_DATA(0x02,0x0f,0x0f,0x0f,0x11,0x70,0x16,0x8e);		// UOgԒn`@rvTf[^if[^tH[}bg(1)APԖڂ̑Mrbg(1)AQԖڂ̑Mrbg(1)AMf[^(13)@vPUoCgj
	__EEPROM_DATA(0x11,0x70,0x16,0x8e,0x11,0x70,0x00,0x00);		// UWgԒn`  DENON DENON PLAY/PAUS Ƀf[^Uɂ



// *****************************
// EEPROM Read/Write
//  : adr=ddoqnl̃AhX(0--255)
//        dat=ddoqnlɏf[^̃|C^A
//			  ͓ǂݏof[^|C^iq`l̕ϐ̃|C^[j
//        wr = 1:Write, 0:Read
//  ̊֐ĂԎɂ͊݋֎~̕KvL
//
//	
//	#define	NUM_ADR		1							// ddoqnlAhX
//	unsigned char	target_number=0;				// q`l̕ϐ
//		.
//		.
//		.
//	eep_read_write(NUM_ADR, &target_number, 1);		// EEPROM Write
//	eep_read_write(NUM_ADR, &target_number, 0);		// EEPROM Read
// *****************************
void	eep_read_write(unsigned char adr, unsigned char *dt, unsigned char wr)
{
	if(wr == 1){					// at Write

		EEADR = adr;
		EEDAT = *dt;
		WREN  = 1;
		EECON2 = 0x55;
		EECON2 = 0xaa;
		WR = 1;
		while(EEIF == 0){			// Wait Write End
			NOP();
		}
		EEIF = 0;
		WREN = 0;

	}else{							// at Read

		EEADR = adr;
		EEPGD = 0;
		CFGS = 0;
		RD = 1;
		*dt = EEDAT;

	}
}

