//*******************************************************
//  PIC 16F1847 ir transciever Program
//  file name: ir_reciever.c
//
//
//   MPLAB IDE v8.84  HiTEC C
//
//  2013/11/18  New  Programed by Taishi
//  2021/08/27  Modify by Taishi ( original:PIC16F1827 LED Blink Program)
//  2021/09/02  Modify by Taishi ( from nixie checker Program) 
//*******************************************************

#include	<htc.h>

#include	"ir_transciever.h"
#include	"dsm_39khz.h"
#include	"lcd.h"
#include	"utility.h"
#include	"ir_eeprom.h"
#include	"ir_transmit.h"
#include	"ir_switch.h"

#include	"ir_reciever.h"

unsigned char	recd[N_OF_BYTE+1];		// ԊOMf[^
unsigned char	n_of_recd;				// ԊOMf[^ioCgj
unsigned char	n_of_recbit;			// ԊOMf[^irbgj
unsigned char	reader_h_on[3];			// [_[̂nmԏWrbg
unsigned char	reader_l_on[3];			// [_[̂nmԉWrbg
unsigned char	reader_h_off[3];		// [_[̂neeԏWrbg
unsigned char	reader_l_off[3];		// [_[̂neeԉWrbg


//*******************************************************
// M[h NEC or AEHDiƓdjor DENON
//*******************************************************
unsigned char	ir_rec_mode_nec_aeha_denon(void)
{
	unsigned char	r=0;

	unsigned char	block;
	unsigned char	i;
	unsigned char	j;
	unsigned char	th;
	unsigned char	tl;
	unsigned char	byte;
	unsigned short	thl;
	unsigned short	thll;
	unsigned short	v_zero_min;					// OƔFŏԒl(uS)
	unsigned short	v_zero_max;					// OƔFő厞Ԓl(uS)
	unsigned short	v_one_min;					// PƔFŏԒl(uS)
	unsigned short	v_one_max;					// PƔFő厞Ԓl(uS)
	unsigned short	v_leader_min;				// [_[ƔFŏԒl(uS)


	for(i=0;i<16;i++){
		recd[i]=0;								// ԊOMf[^@NA
	}
	n_of_recd = 0;								// ԊOMf[^ NA

	reader_h_on[0] = 0;							// [_[̂nmԏWrbg
	reader_l_on[0] = 0;							// [_[̂nmԉWrbg
	reader_h_off[0] = 0;						// [_[̂neeԏWrbg
	reader_l_off[0] = 0;						// [_[̂neeԉWrbg
	reader_h_on[1] = 0;							// [_[̂nmԏWrbg
	reader_l_on[1] = 0;							// [_[̂nmԉWrbg
	reader_h_off[1] = 0;						// [_[̂neeԏWrbg
	reader_l_off[1] = 0;						// [_[̂neeԉWrbg
	reader_h_on[2] = 0;							// [_[̂nmԏWrbg
	reader_l_on[2] = 0;							// [_[̂nmԉWrbg
	reader_h_off[2] = 0;						// [_[̂neeԏWrbg
	reader_l_off[2] = 0;						// [_[̂neeԉWrbg


	i = 0;
	byte = 0;

	if(rec_data_format == AEHA_FORMAT){			// |||@ƓdtH[}bg@|||
		v_zero_min = V_ZERO_MIN_AEHA;			// OƔFŏԒl(uS)
		v_zero_max = V_ZERO_MAX_AEHA;			// OFő厞Ԓl(uS)
		v_one_min = V_ONE_MIN_AEHA;				// PƔFŏԒl(uS)
		v_one_max = V_ONE_MAX_AEHA;				// PƔFő厞Ԓl(uS)
		v_leader_min = V_LEADER_MIN_AEHA;		// [_[ƔFŏԒl(uS)
		block = 1;
	}else if(rec_data_format == DENON_FORMAT){	// |||@cdmnmŗLtH[}bg@|||
		v_zero_min = V_ZERO_MIN_DENON;			// OƔFŏԒl(uS)
		v_zero_max = V_ZERO_MAX_DENON;			// OFő厞Ԓl(uS)
		v_one_min = V_ONE_MIN_DENON;			// PƔFŏԒl(uS)
		v_one_max = V_ONE_MAX_DENON;			// PƔFő厞Ԓl(uS)
		block = 3;
	}else{										// |||@mdbtH[}bg@|||
		v_zero_min = V_ZERO_MIN_NEC;			// OƔFŏԒl(uS)
		v_zero_max = V_ZERO_MAX_NEC;			// OFő厞Ԓl(uS)
		v_one_min = V_ONE_MIN_NEC;				// PƔFŏԒl(uS)
		v_one_max = V_ONE_MAX_NEC;				// PƔFő厞Ԓl(uS)
		v_leader_min = V_LEADER_MIN_NEC;		// [_[ƔFŏԒl(uS)
		block = 1;
	}

	for(j=0;j<block;j++){
		if(rec_data_format == DENON_FORMAT){			// |||@cdmnmŗLtH[}bg@|||
			while(1){									// ԊOnmɂȂ܂ő҂
				if(SW1 != 0){							// SW1ON̎͒f
					i = 0xff;
					break;
				}

				if((PORTB & 0b00000001)==0){			// ԊOM@nmɂȂ
					TMR1H  = 0;							// Uper Reg = 0
					TMR1L  = 0;							// Lower Reg = 0
					break;
				}
			}
		}else{
	// ---------------------- [_[̎ԑ --------------------
			while(1){
				i = 0;
				while(1){									// ԊOnmɂȂ܂ő҂
					if(SW1 != 0){							// SW1ON̎͒f
						i = 0xff;
						break;
					}

					if((PORTB & 0b00000001)==0){			// ԊOM@nmɂȂ
						TMR1H  = 0;							// Uper Reg = 0
						TMR1L  = 0;							// Lower Reg = 0
						break;
					}
				}

				if(i != 0xff){								// fłȂ
					while(1){								// ԊOneeɂȂ܂ő҂
						if(SW1 != 0){						// SW1ON̎͒f
							i = 0xff;
							break;
						}

						if((PORTB & 0b00000001)!=0){		// ԊOM@neeɂȂ
							reader_h_on[j] = TMR1H;			// [_[̂nmԏWrbg
							reader_l_on[j] = TMR1L;			// [_[̂nmԉWrbg
							TMR1H  = 0;						// Uper Reg = 0
							TMR1L  = 0;						// Lower Reg = 0
							thll = reader_h_on[j];
							thll <<= 8;
							thll |= reader_l_on[j];
							break;
						}
					}
				}


				if(i != 0xff){								// fłȂ
					while(1){								// ԊOnmɂȂ܂ő҂
						if(SW1 != 0){						// SW1ON̎͒f
							i = 0xff;
							break;
						}

						if((PORTB & 0b00000001)==0){		// ԊOM@nmɂȂ
							reader_h_off[j] = TMR1H;			// [_[̂neeԏWrbg
							reader_l_off[j] = TMR1L;			// [_[̂neeԉWrbg
							TMR1H  = 0;						// Uper Reg = 0
							TMR1L  = 0;						// Lower Reg = 0
							thl = reader_h_off[j];
							thl <<= 8;
							thl |= reader_l_off[j];
							thl += thll;
							if(v_leader_min <= thl){		// [_[Ɣ
								i = 0xe0;
							}
							break;
						}
					}
				}

				if((i == 0xff)||(i == 0xe0)){
					break;
				}
			}
		}

// ------------------ f[^̑ ------------------------

		if(i != 0xff){									// fłȂ
			PORTB |= 0b00000010;						// fobÖׁ@PB1(blue) ON
			n_of_recbit = 0;							// ԊOMf[^irbgj NA
			i=0;
			while(1){
				if(i < 0xf0){							// fłȂ
					while(1){							// ԊOneeɂȂ܂ő҂
						if(SW1 != 0){					// SW1ON̎͒f
							i = 0xff;
							break;
						}

						if((PORTB & 0b00000001)!=0){	// ԊOM@neeɂȂ
							break;
						}
					}
				}
				while(1){								// ԊOnmɂȂ܂ő҂
					if(SW1 != 0){						// SW1ON̎͒f
						i = 0xff;
						break;
					}

					if((PORTB & 0b00000001)==0){		// ԊOM@nmɂȂ
						th = TMR1H;
						tl = TMR1L;
						TMR1H  = 0;						// Uper Reg = 0
						TMR1L  = 0;						// Lower Reg = 0
						thl = th;
						thl <<= 8;
						thl |= tl;
						if((v_zero_min <= thl)&&(thl <= v_zero_max)){		// OƔ
							;
						}else if((v_one_min <= thl)&&(thl <= v_one_max)){	// PƔ
							byte |= 1;
						}else{												// sȒlƔ
							;												// ͂Ȃ̂ȂiOɂȂj
						}
						n_of_recbit++;					// ԊOMf[^irbgj NA

						if(i < 7){
							byte <<= 1;
							i++;
						}else{							// Wrbg
							recd[n_of_recd] = byte;
							n_of_recd++;
							i = 0;
							byte = 0;
							if(N_OF_BYTE < n_of_recd){	// f[^鎞
								i = 0xf8;
							}
						}

						break;
					}

					th = TMR1H;
					tl = TMR1L;
					thl = th;
					thl <<= 8;
					thl |= tl;
					if(v_one_max < thl){				// Iig[jƔf
						if(i != 0){						// r܂Ńf[^L鎞
							for( ; i < 7;i++){
								byte <<= 1;
							}
							recd[n_of_recd] = byte;
							n_of_recd++;
						}
						i = 0xf0;
						break;
					}
				}
				if(0xf0 <= i){							// f͏I̎
					r = i;
					break;
				}
			}
			PORTB &= ~0b00000010;						//  PB1(blue) OFF
		}else{
			r = 0xff;
		}


		// Ł@ubÑrbg
		if(j == 0){
			trx_data_block.n_of_bit1 = n_of_recbit;
		}else if(j == 1){
			trx_data_block.n_of_bit2 = n_of_recbit;
		}else{
			trx_data_block.n_of_bit3 = n_of_recbit;
		}

		PORTB &= ~0b00000010;						//  PB1(blue) OFF
	}

	// Ł@f[^ƃf[^
	trx_data_block.data_format = rec_data_format;
	for(i=0 ; i < N_OF_BYTE;i++){
		trx_data_block.data_buf[i] = recd[i];
	}


	PORTB &= ~0b00000010;								//  PB1(blue) OFF

	return(r);
}

//*******************************************************
// \[h "SW1 SW2 SW3 SW4 SW5" \
// arg. sel:]\Ԗ
// arg.   y:\s
//*******************************************************
void	ir_SW1_SW5_disp(unsigned char sel,unsigned char y)
{
	unsigned char	i;

	for(i=0;i<5;i++){
		ucs[0]  = 'S';
		ucs[1]  = 'W';
		ucs[2]  = '1'+i;
		ucs[3]  = 0x00;
		if(i== sel){
			disp_lcd_G_reverse(i*4, y, &ucs[0]);	// SW1-5 ]\
		}else{
			disp_lcd_G(i*4, y, &ucs[0]);			// SW1-5 \
		}
	}
}

//*******************************************************
// ddoqnlɎMf[^ۑ
//   ̒ŕۑXCb`w肷
//*******************************************************
void	save_task(void)
{
	unsigned char	i;									// rx data
	unsigned char	n;									// n of rx data
	unsigned char	eep;								// ddoqnl@Mf[^ubÑgbvAhX
	unsigned char	sw_n;

	disp_line_clear_lcd_G(5);							// One Line Clear Display

	sw_n = 0;
	ir_SW1_SW5_disp(sw_n,5);							// SW1-5 \
	wait_all_sw_off();									//	SXCb`nee܂ő҂
	while(1){
		if(SW1 != 0){									// SW1ON̎͒f
			disp_line_clear_lcd_G(5);					// One Line Clear Display
			ucs[0]  = 'C';
			ucs[1]  = 'A';
			ucs[2]  = 'N';
			ucs[3]  = 'C';
			ucs[4]  = 'E';
			ucs[5]  = 'L';
			ucs[6]  = 0x00;
			disp_lcd_G(8, 5, &ucs[0]);					// b`mbdk\
			sw_n = 0xff;
			break;
		}
		if(SW3 != 0){									// ۑXCb`̑I{
			if(sw_n < 4){
				sw_n++;
			}else{
				sw_n = 0;
			}
			ir_SW1_SW5_disp(sw_n,5);					// SW1-5 \
			wait_all_sw_off();							//	SXCb`nee܂ő҂
		}
		if(SW4 != 0){									// ۑXCb`̑I
			disp_line_clear_lcd_G(5);					// One Line Clear Display
			ucs[0]  = 'E';
			ucs[1]  = 'E';
			ucs[2]  = 'P';
			ucs[3]  = ' ';
			ucs[4]  = 'S';
			ucs[5]  = 'A';
			ucs[6]  = 'V';
			ucs[7]  = 'E';
			ucs[8]  = 0x00;
			disp_lcd_G_reverse(0, 5, &ucs[0]);			// ddo@r`ud\
			break;
		}
	}

	if(sw_n <= 4){
		PORTB |= 0b00000010;							// PB1(blue LED) ON
		eep = EEP_TRX_DATA+((sw_n)*16);

		eep_read_write(eep+EEP_OFS_F,  &trx_data_block.data_format, 1);			// EEPROM Write data format
		eep_read_write(eep+EEP_OFS_N1, &trx_data_block.n_of_bit1, 1);			// EEPROM Write N of bit 1'st Pattern
		eep_read_write(eep+EEP_OFS_N2, &trx_data_block.n_of_bit2, 1);			// EEPROM Write N of bit 2'nd Pattern
		eep_read_write(eep+EEP_OFS_N3, &trx_data_block.n_of_bit3, 1);			// EEPROM Write N of bit 3'rd Pattern

		n = N_OF_BYTE;
		for(i = 0; i < n; i++){
			eep_read_write(eep+EEP_OFS_D + i, &trx_data_block.data_buf[i], 1);	// EEPROM Write RX data
		}
	}

	wait_all_sw_off();									//	SXCb`nee܂ő҂
	disp_line_clear_lcd_G(5);							// One Line Clear Display
	PORTB &= ~0b00000010;								// PB1(blue LED) OFF


}

//*******************************************************
// ԊOkdcM
//*******************************************************
void	ir_out_task(void)
{
	if(rec_data_format == AEHA_FORMAT){			// |||@ƓdtH[}bg@|||
		v_zero_on = V_ZERO_ON_AEHA;				// [nmԁ@irj
		v_zero_off = V_ZERO_OFF_AEHA;			// [neeԁirj
		v_one_on = V_ONE_ON_AEHA;				// P@nmԁ@irj
		v_one_off = V_ONE_OFF_AEHA;				// P@neeԁirj
		v_leader_on = V_LEADER_ON_AEHA;			// [_[nmԁ@irj
		v_leader_off = V_LEADER_OFF_AEHA;		// [_[neeԁirj
		v_trailer_on = V_TRAILER_ON_AEHA;		// g|[@nmԁ@irj
		v_trailer_off = V_TRAILER_OFF_AEHA;		// g[[@neeԁirj

	}else if(rec_data_format == DENON_FORMAT){	// |||@cdmnmŗLtH[}bg@|||
		v_zero_on = V_ZERO_ON_DENON;			// [nmԁ@irj
		v_zero_off = V_ZERO_OFF_DENON;			// [neeԁirj
		v_one_on = V_ONE_ON_DENON;				// P@nmԁ@irj
		v_one_off = V_ONE_OFF_DENON;			// P@neeԁirj
		v_leader_on = V_LEADER_ON_DENON;		// [_[nmԁ@irj
		v_leader_off = V_LEADER_OFF_DENON;		// [_[neeԁirj
		v_trailer_on = V_TRAILER_ON_DENON;		// g|[@nmԁ@irj
		v_trailer_off = V_TRAILER_OFF_DENON;	// g[[@neeԁirj

	}else{										// |||@mdbtH[}bg@|||
		v_zero_on = V_ZERO_ON_NEC;				// [nmԁ@irj
		v_zero_off = V_ZERO_OFF_NEC;			// [neeԁirj
		v_one_on = V_ONE_ON_NEC;				// P@nmԁ@irj
		v_one_off = V_ONE_OFF_NEC;				// P@neeԁirj
		v_leader_on = V_LEADER_ON_NEC;			// [_[nmԁ@irj
		v_leader_off = V_LEADER_OFF_NEC;		// [_[neeԁirj
		v_trailer_on = V_TRAILER_ON_NEC;		// g|[@nmԁ@irj
		v_trailer_off = V_TRAILER_OFF_NEC;		// g[[@neeԁirj
	}

	tx_nec_aeha_denon_form_new_str(trx_data_block.n_of_bit1,trx_data_block.n_of_bit2,trx_data_block.n_of_bit3, &trx_data_block.data_buf[0]);

}

//*******************************************************
// XCb`얼̕\
// arg.   y:\s
//*******************************************************
void	sw_name_disp(unsigned char y)
{
	ucs[0]  = 'S';
	ucs[1]  = 'W';
	ucs[2]  = '4';
	ucs[3]  = ':';
	ucs[4]  = 'S';
	ucs[5]  = 'A';
	ucs[6]  = 'V';
	ucs[7]  = 'E';
	ucs[8]  = ' ';
	ucs[9]  = ' ';
	ucs[10]  = 'S';
	ucs[11]  = 'W';
	ucs[12]  = '5';
	ucs[13]  = ':';
	ucs[14]  = 'T';
	ucs[15]  = 'R';
	ucs[16]  = 'N';
	ucs[17]  = 'S';
	ucs[18]  = 'M';
	ucs[19]  = 'I';
	ucs[20]  = 'T';
	ucs[21]  = 0x00;
	disp_lcd_G(0, y, &ucs[0]);			// SW4:SAVE  SW5:TRANS \
}

//*******************************************************
// \[h
//*******************************************************
void	ir_rec_disp_mode(void)
{
	unsigned char	i;
	unsigned char	sel_sw;
	unsigned short	thl;

	disp_clear_lcd_G();								// Clear Display

	init_dsm();										// DSM(Digital Signal Modurator) ̐ݒ@inm^neeL[COj


	if((rec_data_format != DENON_FORMAT)&&(reader_h_on[0] == 0) && (reader_l_on[0] == 0) && (reader_h_off[0] == 0) && (reader_l_off[0] == 0)){		// [_[Ԃ𑪂ĂȂ
		;											// fƔfiȂj
	}else{
		ucs[0]  = 'R';
		ucs[1]  = 'E';
		ucs[2]  = 'C';
		ucs[3]  = '.';
		ucs[4]  = 0x00;
		disp_lcd_G(0, 0, &ucs[0]);					// REC

		set_format_name(rec_data_format);			//  f[^tH[}bg̃Zbg
		disp_lcd_G(5, 0, &ucs[0]);					// format display

		if(rec_data_format != DENON_FORMAT){
			ucs[0]  = 'O';
			ucs[1]  = 'N';
			ucs[2]  = ':';
			ucs[3]  = 0x00;
			disp_lcd_G(0, 1, &ucs[0]);				// ON:
			thl = reader_h_on[0];
			thl <<= 8;
			thl |= reader_l_on[0];
			wtod_05u(&ucs[0], thl);					// QoCgf[^T̂POî`rbhhɕϊ
			disp_lcd_G(3, 1, &ucs[0]);				// [_[\inmԁj

			ucs[0]  = 'O';
			ucs[1]  = 'F';
			ucs[2]  = 'F';
			ucs[3]  = ':';
			ucs[4]  = 0x00;
			disp_lcd_G(10, 1, &ucs[0]);				// OFF:

			thl = reader_h_off[0];
			thl <<= 8;
			thl |= reader_l_off[0];
			wtod_05u(&ucs[0], thl);					// QoCgf[^T̂POî`rbhhɕϊ
			disp_lcd_G(14, 1, &ucs[0]);				// [_[\ineeԁj
		}
	}

	if(n_of_recd == 0){								// Mf[^
		ucs[0]  = 'N';
		ucs[1]  = 'O';
		ucs[2]  = ' ';
		ucs[3]  = 'D';
		ucs[4]  = 'A';
		ucs[5]  = 'T';
		ucs[6]  = 'A';
		ucs[7]  = 0x00;
		disp_lcd_G(7, 2, &ucs[0]);					// mn@c`s`\
	}else{											// ŎMf[^\

		n_of_data_disp(2);							// f[^\

		if( n_of_recd <= 6){						// f[^Uȉ̎
			for(i=0; i<n_of_recd;i++){
				wtod_02x(&ucs[0],recd[i]);
				disp_lcd_G(i*3, 3, &ucs[0]);		// f[^\iOŌ܂Łj
			}
		}else{
			for(i=0; i<6;i++){
				wtod_02x(&ucs[0],recd[i]);
				disp_lcd_G(i*3, 3, &ucs[0]);		// f[^\iOTԖڂ܂Łj
			}
			for(i=6; i<n_of_recd;i++){
				wtod_02x(&ucs[0],recd[i]);
				disp_lcd_G((i-6)*3, 4, &ucs[0]);	// f[^\iUŌ܂Łj
			}
		}
	}

	sw_name_disp(5);								// XCb`얼̕\

	wait_all_sw_off();								//	SXCb`nee܂ő҂
	while(1){
		if(SW1 != 0){								// SW1ON̎͒f
			break;
		}
		if(SW4 != 0){								// ۑXCb`̑I
			save_task();							// ddoqnlɕۑ
			sw_name_disp(5);						// XCb`얼̕\
			PORTB &= ~0b00000010;					// PB1(blue LED) OFF
		}
		if(SW5 != 0){								// MXCb`
			ucs[0]  = 'T';
			ucs[1]  = 'R';
			ucs[2]  = 'A';
			ucs[3]  = 'S';
			ucs[4]  = 'M';
			ucs[5]  = 'I';
			ucs[6]  = 'T';
			ucs[7]  = 0x00;
			disp_lcd_G_reverse(14, 5, &ucs[0]);		// sq`mrls\
			valid_dsm();							// DSM L
			ir_out_task();							// ԊOkdcM
			invalid_dsm();							// DSM 
			wait_all_sw_off();						//	SXCb`nee܂ő҂
			sw_name_disp(5);						// XCb`얼̕\
			PORTB &= ~0b00000010;					// PB1(blue LED) OFF
		}
	}

}

//*******************************************************
//		M
//*******************************************************
void	ir_recieve_main(void)
{
	unsigned char	r;

	while(1){
		disp_clear_lcd_G();							// Clear Display

		ucs[0]  = 'R';
		ucs[1]  = 'E';
		ucs[2]  = 'C';
		ucs[3]  = 'I';
		ucs[4]  = 'E';
		ucs[5]  = 'V';
		ucs[6]  = 'E';
		ucs[7]  = 0x00;
		disp_lcd_G_10x16(0, 0, &ucs[0]);			// format \

		wait_all_sw_off();							//	SXCb`nee܂ő҂

		if(rec_data_format == DENON_FORMAT){
			ucs[0]  = 'D';
			ucs[1]  = 'E';
			ucs[2]  = 'N';
			ucs[3]  = 'O';
			ucs[4]  = 'N';
			ucs[5]  = 0x00;
			disp_lcd_G_10x16(1, 1, &ucs[0]);		// format \
			r = ir_rec_mode_nec_aeha_denon();		// M[h aehd data and nec data
		}else if(rec_data_format == AEHA_FORMAT){
			ucs[0]  = 'A';
			ucs[1]  = 'E';
			ucs[2]  = 'H';
			ucs[3]  = 'A';
			ucs[4]  = 0x00;
			disp_lcd_G_10x16(1, 1, &ucs[0]);		// format \
			r = ir_rec_mode_nec_aeha_denon();		// M[h aehd data and nec data
		}else{
			ucs[0]  = 'N';
			ucs[1]  = 'E';
			ucs[2]  = 'C';
			ucs[3]  = ' ';
			ucs[4]  = ' ';
			ucs[5]  = 0x00;
			disp_lcd_G_10x16(1, 1, &ucs[0]);		// format \
			r = ir_rec_mode_nec_aeha_denon();		// M[h nec data and aehd data
		}

		if(r != 0xff){								// fłȂ
			ir_rec_disp_mode();						// \[h
		}
	}
}
