//*******************************************************
//  PIC 16F1847 ir transciever Program
//  file name: ir_transciever_main.c
//
//
//   MPLAB IDE v8.84  HiTEC C
//
//  2013/11/18  New  Programed by Taishi
//  2021/08/27  Modify by Taishi ( original:PIC16F1827 LED Blink Program)
//  2021/09/02  Modify by Taishi ( from nixie checker Program) 
//*******************************************************

#include	<htc.h>

#include	"ir_transciever.h"
#include	"dsm_39khz.h"
#include	"lcd.h"
#include	"utility.h"
#include	"ir_eeprom.h"
#include	"ir_transmit.h"
#include	"ir_switch.h"
#include	"ir_reciever.h"

//#define	_XTAL_FREQ	32000000L	//	giWlgS{j

// CONFIG for 16F1847

__CONFIG (	FCMEN_OFF			//	0(OFF) = tFCZ[t NbNj^𖳌ɂ
		&	IESO_OFF			//	0(OFF) = tFCZ[t NbNj^𖳌ɂ
		&	CLKOUTEN_OFF		//	1(OFF) = CLKOUT@\𖳌ɂBCLKOUT sI/O Ƃċ@\
		&	BOREN_ON			//	11 = BOR(uEAEgZbg)Lɂ
		&	CPD_OFF				//	1(OFF) = f[^̃R[hی𖳌ɂ
		&	CP_OFF				//	1(OFF) = vÕR[hی𖳌ɂ
		&	MCLRE_ON			//	1(ON) = MCLR/VPP s̓Zbg[qƂċ@\B
		&	PWRTE_ON			//	0 = PWRT(p[Abv^C}[)Lɂ
		&	WDTE_OFF			//	00 = WDT(EHb`hbO^C}[)𖳌ɂ
		&	FOSC_INTOSC			//	100 = INTOSCIV[^:CLKIN sI/O Ƃċ@\
);

								//	fobO@\͏ݑuɔCij

__CONFIG (	LVP_OFF				//	0(OFF)=vO~OMCLR ɍdKv
		&	BORV_LO				//	1 = uEAEgZbgd(Vbor)̃gbv|Cgɐݒ肷
		&	STVREN_ON			//	1(ON) = X^bÑI[o[t[܂̓A_[t[ɂăZbg𔭐
		&	PLLEN_ON			//	1 = 4xPLL Lɂ
		&	WRT_OFF				//	11 = ݕیOFF ɂ
);

DATA_BLOCK	trx_data_block;				// Mp̃f[^ubN
unsigned char	dousa = DOUSA_REC;		// iM@́@Mj
unsigned char	rec_data_format;		// M̎Mf[^tH[}bgĩtH[}bgɑAMj

//*******************************************************
// w莞Ԃ̑҂
//  arg us : wait time(uS)
//  \߁@P͏ݒĂ镨Ƃ
//    iPrPʂŃJEgĂ镨Ƃj
//*******************************************************
void	wait_us(unsigned short us)
{
	unsigned short	thll;

	TMR1H  = 0;							// Uper Reg = 0
	TMR1L  = 0;							// Lower Reg = 0

	while(1){
		thll = TMR1H;
		thll <<= 8;
		thll |= TMR1L;
		if(us <= thll){
			break;
		}
	}
}
//*******************************************************
// w莞Ԃ̑҂
//  arg us : wait time(mS)
//  \߁@P͏ݒĂ镨Ƃ
//    iPrPʂŃJEgĂ镨Ƃj
//*******************************************************
void	wait_ms(unsigned short us)
{
	unsigned short	i;

	for(i=0;i<us;i++){
		wait_us(1000);
	}
}

//*******************************************************
// XCb`@\\
//*******************************************************
void	sw_func_disp(unsigned short y)
{
	ucs[0]  = 'S';
	ucs[1]  = 'W';
	ucs[2]  = '3';
	ucs[3]  = ':';
	ucs[4]  = 'S';
	ucs[5]  = 'E';
	ucs[6]  = 'L';
	ucs[7]  = 'E';
	ucs[8]  = 'C';
	ucs[9]  = 'T';
	ucs[10]  = ' ';	

	ucs[11]  = 'S';
	ucs[12]  = 'W';
	ucs[13]  = '1';
	ucs[14]  = ':';
	ucs[15]  = 'E';
	ucs[16]  = 'N';
	ucs[17]  = 'T';
	ucs[18]  = 'E';
	ucs[19]  = 'R';
	ucs[20]  = 0x00;
	disp_lcd_G(0, y, &ucs[0]);					// "SW3:SELECT SW1:ENTER" \
}

//*******************************************************
// ddoqnlɓۑƓǂݏo
//    arg.  wr = 1:Write, 0:Read
//   ۑ dousa ɓ삪Ă
//   Ǐo dousa ɓ삪
//*******************************************************
void	save_load_dousa(unsigned char wr)
{
	eep_read_write(EEP_TRANS_REC,  &dousa, wr);			// EEPROM Write or Read data format
}

//*******************************************************
// select transmit or recieve
//*******************************************************
void	sel_dousa(void)
{
	unsigned char	uc_dousa;
	unsigned char	i = 0;

	uc_dousa = dousa;

	ucs[0]  = 'R';
	ucs[1]  = 'E';
	ucs[2]  = 'C';
	ucs[3]  = '.';
	ucs[4]  = ' ';
	ucs[5]  = 'T';
	ucs[6]  = 'R';
	ucs[7]  = 'N';
	ucs[8]  = 'S';
	ucs[9]  = 0x00;
	disp_lcd_G_10x16(0, 0, &ucs[0]);						// "REC.  TRANS" \

	wait_all_sw_off();										//	SXCb`nee܂ő҂

	ucs[0]  = 0x81;
	ucs[1]  = 0x81;
	ucs[2]  = 0x81;
	ucs[3]  = 0x81;
	ucs[4]  = 0x00;
	disp_lcd_G_10x16(uc_dousa * 5, 1, &ucs[0]);				// "~~" \

	sw_func_disp(4);										// XCb`@\\

	while(1){
		i = get_sw_on();									//	XCb`nm擾
		if(i != 0){
			if(i==1){
				break;
			}else if(i == 3){
				ucs[0]  = ' ';
				ucs[1]  = ' ';
				ucs[2]  = ' ';
				ucs[3]  = ' ';
				ucs[4]  = 0x00;
				disp_lcd_G_10x16(uc_dousa * 5, 1, &ucs[0]);	// "  " \
				uc_dousa ^= 1;
				ucs[0]  = 0x81;
				ucs[1]  = 0x81;
				ucs[2]  = 0x81;
				ucs[3]  = 0x81;
				ucs[4]  = 0x00;
				disp_lcd_G_10x16(uc_dousa * 5, 1, &ucs[0]);	// "~~" \
			}
			wait_all_sw_off();								//	SXCb`nee܂ő҂
		}
	}

	if(dousa != uc_dousa){
		dousa = uc_dousa;
		save_load_dousa(1);									// ddoqnlɓۑ
	}
}

//*******************************************************
// Mf[^tH[}bg̕\
// sel:]\Ԗ
//   y:\s
//*******************************************************
void	rec_format_disp(unsigned char sel,unsigned char y)
{

	ucs[0]  = 'D';
	ucs[1]  = 'E';
	ucs[2]  = 'N';
	ucs[3]  = 'O';
	ucs[4]  = 'N';
	ucs[5]  = 0x00;
	if(DENON_FORMAT == sel){
		disp_lcd_G_reverse((6 * DENON_FORMAT), y, &ucs[0]);	// DENON ]\
	}else{
		disp_lcd_G((6 * DENON_FORMAT), y, &ucs[0]);			// DENON \
	}

	ucs[0]  = 'A';
	ucs[1]  = 'E';
	ucs[2]  = 'H';
	ucs[3]  = 'A';
	ucs[4]  = 0x00;
	if(AEHA_FORMAT == sel){
		disp_lcd_G_reverse((6 * AEHA_FORMAT), y, &ucs[0]);	// AEHA ]\
	}else{
		disp_lcd_G((6 * AEHA_FORMAT), y, &ucs[0]);			// AEHA \
	}

	ucs[0]  = 'N';
	ucs[1]  = 'E';
	ucs[2]  = 'C';
	ucs[3]  = 0x00;
	if(NEC_FORMAT == sel){
		disp_lcd_G_reverse((6 * NEC_FORMAT), y, &ucs[0]);	// NEC ]\
	}else{
		disp_lcd_G((6 * NEC_FORMAT), y, &ucs[0]);			// NEC \
	}

}

//*******************************************************
//  Mf[^tH[}bg̑I
//*******************************************************
void	sel_rec_format(void)
{
	unsigned char uc_form;
	unsigned char i;

	disp_clear_lcd_G();							// Clear Display

	uc_form = rec_data_format;

	ucs[0]  = 'R';
	ucs[1]  = 'E';
	ucs[2]  = 'C';
	ucs[3]  = 'I';
	ucs[4]  = 'E';
	ucs[5]  = 'V';
	ucs[6]  = 'E';
	ucs[7]  = 0x00;
	disp_lcd_G_10x16(0, 0, &ucs[0]);			// RECIEVE \

	ucs[0]  = 'F';
	ucs[1]  = 'O';
	ucs[2]  = 'M';
	ucs[3]  = 'A';
	ucs[4]  = 'T';
	ucs[5]  = ' ';
	ucs[6]  = 'S';
	ucs[7]  = 'E';
	ucs[8]  = 'L';
	ucs[9]  = 0x00;
	disp_lcd_G_10x16(0, 1, &ucs[0]);			// format SEL \

	sw_func_disp(5);							// XCb`@\\

	rec_format_disp(uc_form,4);					// Mf[^tH[}bg̕\

	wait_all_sw_off();							//	SXCb`nee܂ő҂

	while(1){
		i = get_sw_on();						//	XCb`nm擾
		if(i != 0){
			if(i==1){
				break;
			}else if(i == 3){
				if(uc_form < END_FORMAT-1 ){
					uc_form++;
				}else{
					uc_form = 0;
				}
				rec_format_disp(uc_form,4);		// Mf[^tH[}bg̕\
			}
			wait_all_sw_off();					//	SXCb`nee܂ő҂
		}
	}

	if(rec_data_format != uc_form){
		rec_data_format = uc_form;
		eep_read_write(EEP_REC_FORMAT,  &rec_data_format, 1);			// ddoqnlɎMf[^tH[}bgۑ
	}

}
//*******************************************************
// C
//*******************************************************
void	main(void)
{
	unsigned char	i;
	unsigned char	count=0;	// Pbp̃JE^[(0 --> 49, 20msx50=1000mS)
	unsigned char	run=0;		// 0:ԍfA 1:ԍA 2:̔ԍ\v
	unsigned char	no=0xff;	// jLV[ǂ̕\ԍ(0:K1-->8=K9, 9=K0, 10=DP-R, 11=DP-L)

	di();						//	荞݋֎~

//				76543210
	OSCCON	= 0b01110000;		//	NbNWlg@c@okkHLȂ̂ŎRQlg

//				76543210		//  |[g`
	ANSELA	= 0b00000000;		//	ăfW^óiAiO͋֎~j
	PORTA	= 0b00111111;		//	o̓f[^ݒ(RA6,7 ͂O)
	TRISA	= 0b00111111;		//	o͕ݒ(RA6,7 ͏o)
	WPUA	= 0b00100000;		//	vAbvݒ(PA5:ON vAbvÃrbgɂ̓vAbv݂͑Ȃ)

//				76543210		//  |[ga
	ANSELB	= 0b00000000;		//	ăfW^óiAiO͋֎~j
	PORTB	= 0b00000001;		//	o̓f[^ݒ(oaOȊOSĂO)
	TRISB	= 0b00000001;		//	o͕ݒ(oaOȊOSďo)
	WPUB	= 0b00000001;		//	vAbvݒ(oaOȊOSăvAbv)

	OPTION_REGbits.nWPUEN = 0;	// WPUEN:0 vAbvL


// --------------------------------------------------------------------------------
// --------------@n[h`FbÑvO@----------------------------
// ||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

// --------- Fkdc _ ---------
// ------- iɖPbԊuœ_ --------
#ifdef	HARD1_BLUE_ON_OFF

	while(1){
		PORTB ^= 0b00000010;	//  PB1(blue) ON or OFF
		__delay_ms(500);		//	TOOҋ@;
	}

#endif

// --------- FkdcƐԊOkdc_ ---------
// --------- iɖPbԊuŌ݂ɓ_ ---------
#ifdef	HARD2_IR_BLUE_ON_OFF

	PORTB &= ~(0b00000010);		//  PB1(blue) OFF
	PORTB |=   0b00001000;		//  PB3 (IR) ON
	while(1){
		PORTB ^= 0b00001010;	//  PB1(blue) & PB3(IR) ON or OFF
		__delay_ms(500);		//	TOOҋ@;
	}

#endif

// ------------ kbcɕ\ ----------------
// ------- iɉp\ -------
#ifdef	HARD3_LCD_DISP

	init_lcd_G();					// Init. LCD

	while(1){
		disp_lcd_G_font_check1();
		__delay_ms(1000);			//	Pҋ@
		disp_lcd_G_font_check2();
		__delay_ms(1000);			//	Pҋ@
		disp_lcd_G_font_check3();
		__delay_ms(1000);			//	Pҋ@
	}

#endif


// --------- nmXCb`kbcɕ\ ---------
#ifdef	HARD4_SWITCH_DISP	1			// ʏ̓RgAEg

	init_lcd_G();									// Init. LCD

	ucs[0]  = 'S';
	ucs[1]  = 'W';
	ucs[2]  = '-';
	ucs[3]  = 'T';
	ucs[4]  = 'E';
	ucs[5]  = 'S';
	ucs[6]  = 'T';
	ucs[7]  = 0x00;
	disp_lcd_G_15x24(0, 0, &ucs[0]);				// rv|sdrs \

	i=0;
	while(1){
		i = get_sw_on();							//	XCb`nm擾

		if(i != 0){
			ucs[0]  = 'S';
			ucs[1]  = 'W';
			ucs[2]  = '0'+i;
			ucs[3]  = 0x00;
			disp_lcd_G_15x24(0, 1, &ucs[0]);		// rvP||T \
			__delay_ms(250);						//	QUOҋ@;
			wait_all_sw_off();						//	SXCb`nee܂ő҂
			i = 0;
			ucs[0]  = ' ';
			ucs[1]  = ' ';
			ucs[2]  = ' ';
			ucs[3]  = 0x00;
			disp_lcd_G_15x24(0, 1, &ucs[0]);		// rvQQQQ \
		}
	}

#endif


// --------- ԊȌo͂ŐFkdc_ ---------
#ifdef	HARD5_IR_BLUE
	while(1){
		if((PORTB & 0b00000001)==0){			// ԊOM@nmɂȂ
			PORTB |= 0b00000010;				//  PB1(blue) ON
			__delay_ms(100);					//	POOҋ@;
		}else{
			PORTB &= ~(0b00000010);				//  PB1(blue) OFF
		}
	}

#endif

// ||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
// --------------@܂Ńn[h`FbÑvO@----------------------------
// --------------------------------------------------------------------------------


	// Timer1 Init.
	T1CON  = 0b00110001;											// Fosc/4, prescaler 1/8, timer1osc:dis, sync Fosc, 
	T1GCON = 0b00000000;											// Timer1 Not Link Gate
	TMR1H  = 0;														// Uper Reg
	TMR1L  = 0;														// Lower Reg


	init_lcd_G();													// Init. LCD

	save_load_dousa(0);												// ddoqnl瓮ǂ
	if(DOUSA_END <= dousa){											// 삪͈͊O̎
		dousa = DOUSA_REC;
		save_load_dousa(1);											// ddoqnlɓۑ
	}

	eep_read_write(EEP_REC_FORMAT,  &rec_data_format, 0);			// ddoqnlMf[^tH[}bgǂ
	if(END_FORMAT <= rec_data_format){								// Mf[^tH[}bg͈͊O̎
		rec_data_format = NEC_FORMAT;
		eep_read_write(EEP_REC_FORMAT,  &rec_data_format, 1);		// ddoqnlɎMf[^tH[}bgۑ
	}

	if(SW1 != 0){													// SW1:ON
		sel_dousa();												// select transmit or recieve
		if(dousa == DOUSA_REC){
			sel_rec_format();
		}
	}

	if(dousa == DOUSA_REC){
		ir_recieve_main();											// M
	}else{
		ir_transmit_main();											// M
	}

}
