//*******************************************************
//  PIC 16F1847 ir transciever Program
//  file name: ir_transmit.c
//
//
//   MPLAB IDE v8.84  HiTEC C
//
//  2013/11/18  New  Programed by Taishi
//  2021/08/27  Modify by Taishi ( original:PIC16F1827 LED Blink Program)
//  2021/09/02  Modify by Taishi ( from remote for TV) 
//*******************************************************

#include	<htc.h>

#include	"ir_transciever.h"
#include	"dsm_39khz.h"
#include	"lcd.h"
#include	"utility.h"
#include	"ir_eeprom.h"
#include	"ir_switch.h"

#include	"ir_transmit.h"

//*******************************************************
//  f[^tH[}bg̃Zbg
//  arg fn : f[^tH[}bg
//	         NEC_FORMAT = 0,				// mdbtH[}bg
//	         AEHA_FORMAT,					// ƓdtH[}bg
//	         SONY_FORMAT,					// rnmxtH[}bg
//	         DENON_FORMAT,					// cdmnmŗLtH[}bg
//
//   ͍̂Ł@ucs[0]--[5] ɓB^[~l[^[5]ɂOOO
//*******************************************************
void	set_format_name(unsigned char fm)
{
	if(fm == DENON_FORMAT){
		ucs[0]  = 'D';
		ucs[1]  = 'E';
		ucs[2]  = 'N';
		ucs[3]  = 'O';
		ucs[4]  = 'N';
		ucs[5]  = 0x00;
	}else if(fm == AEHA_FORMAT){
		ucs[0]  = 'A';
		ucs[1]  = 'E';
		ucs[2]  = 'H';
		ucs[3]  = 'A';
		ucs[4]  = ' ';
		ucs[5]  = 0x00;
	}else{
		ucs[0]  = 'N';
		ucs[1]  = 'E';
		ucs[2]  = 'C';
		ucs[3]  = ' ';
		ucs[4]  = ' ';
		ucs[5]  = 0x00;
	}
}

//*******************************************************
// Mf[^̃Zbg
//   ddoqnlǂݏo
//   arg sw : switch number (1 -- 5)
//*******************************************************
void	set_trans_data_set(unsigned char sw)
{
	unsigned char	i;														// tx data
	unsigned char	n;														// n of tx data
	unsigned char	eep;													// ddoqnl@Mf[^ubÑgbvAhX

	eep = EEP_TRX_DATA+((sw-1)*16);
	eep_read_write(eep+EEP_OFS_F,  &trx_data_block.data_format, 0);			// EEPROM Read data format
	eep_read_write(eep+EEP_OFS_N1, &trx_data_block.n_of_bit1, 0);			// EEPROM Read N of bit 1'st Pattern
	eep_read_write(eep+EEP_OFS_N2, &trx_data_block.n_of_bit2, 0);			// EEPROM Read N of bit 2'nd Pattern
	eep_read_write(eep+EEP_OFS_N3, &trx_data_block.n_of_bit3, 0);			// EEPROM Read N of bit 3'rd Pattern

	n = N_OF_BYTE;
	for(i = 0; i < n; i++){
		eep_read_write(eep+EEP_OFS_D + i, &trx_data_block.data_buf[i], 0);	// EEPROM Read TX data
	}
}
//*******************************************************
// f[^\
// arg.   y:\s
//*******************************************************
void	n_of_data_disp(unsigned char y)
{
	ucs[0]  = 'N';
	ucs[1]  = '1';
	ucs[2]  = ':';
	ucs[3]  = 0x00;
	disp_lcd_G(0, y, &ucs[0]);
	wtod_03u(&ucs[0], trx_data_block.n_of_bit1);		// PoCgf[^Q̂POî`rbhhɕϊ
	disp_lcd_G(3, y, &ucs[0]);							// f[^\

	if(trx_data_block.n_of_bit2 != 0){
		ucs[0]  = 'N';
		ucs[1]  = '2';
		ucs[2]  = ':';
		ucs[3]  = 0x00;
		disp_lcd_G(7, y, &ucs[0]);
		wtod_03u(&ucs[0], trx_data_block.n_of_bit2);	// PoCgf[^Q̂POî`rbhhɕϊ
		disp_lcd_G(10, y, &ucs[0]);						// f[^\
	}

	if(trx_data_block.n_of_bit3 != 0){
		ucs[0]  = 'N';
		ucs[1]  = '3';
		ucs[2]  = ':';
		ucs[3]  = 0x00;
		disp_lcd_G(14, y, &ucs[0]);
		wtod_03u(&ucs[0], trx_data_block.n_of_bit3);	// PoCgf[^Q̂POî`rbhhɕϊ
		disp_lcd_G(17, y, &ucs[0]);						// f[^\
	}
}

//*******************************************************
// M̑M[h
//*******************************************************
void	ir_trans_mode(void)
{
	unsigned char	sw = 0;
	unsigned char	i;
	unsigned char	n;
	unsigned char	n1;									// PԖڑMf[^
	unsigned char	n2;									// QԖڑMf[^
	unsigned char	n3;									// RԖڑMf[^
	unsigned char	*s;									// Mf[^gbv

	init_dsm();											// DSM(Digital Signal Modurator) ̐ݒ@inm^neeL[COj

	while(1){
		sw = get_sw_on();											//	XCb`nm擾
		if(sw != 0){												// XCb`Ă鎞
			set_trans_data_set(sw);									// Mf[^̃Zbg

			s = &trx_data_block.data_buf[0];

			valid_dsm();											// DSM L
			if(trx_data_block.data_format == DENON_FORMAT){			// Transmit DENON Clock format new
				v_zero_on = V_ZERO_ON_DENON;						// [nmԁ@irj
				v_zero_off = V_ZERO_OFF_DENON;						// [neeԁirj
				v_one_on = V_ONE_ON_DENON;							// P@nmԁ@irj
				v_one_off = V_ONE_OFF_DENON;						// P@neeԁirj
				v_leader_on = V_LEADER_ON_DENON;					// [_[nmԁ@irj
				v_leader_off = V_LEADER_OFF_DENON;					// [_[neeԁirj
				v_trailer_on = V_TRAILER_ON_DENON;					// g|[@nmԁ@irj
				v_trailer_off = V_TRAILER_OFF_DENON;				// g[[@neeԁirj

			}else if(trx_data_block.data_format == AEHA_FORMAT){	// Transmit AEHA format new
				v_zero_on = V_ZERO_ON_AEHA;							// [nmԁ@irj
				v_zero_off = V_ZERO_OFF_AEHA;						// [neeԁirj
				v_one_on = V_ONE_ON_AEHA;							// P@nmԁ@irj
				v_one_off = V_ONE_OFF_AEHA;							// P@neeԁirj
				v_leader_on = V_LEADER_ON_AEHA;						// [_[nmԁ@irj
				v_leader_off = V_LEADER_OFF_AEHA;					// [_[neeԁirj
				v_trailer_on = V_TRAILER_ON_AEHA;					// g|[@nmԁ@irj
				v_trailer_off = V_TRAILER_OFF_AEHA;					// g[[@neeԁirj

			}else{													// Transmit NEC format new
				v_zero_on = V_ZERO_ON_NEC;							// [nmԁ@irj
				v_zero_off = V_ZERO_OFF_NEC;						// [neeԁirj
				v_one_on = V_ONE_ON_NEC;							// P@nmԁ@irj
				v_one_off = V_ONE_OFF_NEC;							// P@neeԁirj
				v_leader_on = V_LEADER_ON_NEC;						// [_[nmԁ@irj
				v_leader_off = V_LEADER_OFF_NEC;					// [_[neeԁirj
				v_trailer_on = V_TRAILER_ON_NEC;					// g|[@nmԁ@irj
				v_trailer_off = V_TRAILER_OFF_NEC;					// g[[@neeԁirj
			}

			tx_nec_aeha_denon_form_new_str(trx_data_block.n_of_bit1,trx_data_block.n_of_bit2,trx_data_block.n_of_bit3, s);

			invalid_dsm();											// DSM 

			disp_line_clear_lcd_G(2);								// One Line Clear Display
			disp_line_clear_lcd_G(3);								// One Line Clear Display
			disp_line_clear_lcd_G(4);								// One Line Clear Display
			disp_line_clear_lcd_G(5);								// One Line Clear Display

			set_format_name(trx_data_block.data_format);			//  f[^tH[}bg̃Zbg
			disp_lcd_G(15, 0, &ucs[0]);								// f[^tH[}bg\

			ucs[0]  = 'S';
			ucs[1]  = 'W';
			ucs[2]  = '0'+sw;
			ucs[3]  = 0x00;
			disp_lcd_G(15, 1, &ucs[0]);

			n  = (trx_data_block.n_of_bit1 + 7)/8;
			n += (trx_data_block.n_of_bit2 + 7)/8;
			n += (trx_data_block.n_of_bit3 + 7)/8;

			n_of_data_disp(2);										// f[^\
			s = &trx_data_block.data_buf[0];
			for(i=0; i<n;i++, s++){
				wtod_02x(&ucs[0], *s);
				if(i < 6){
					disp_lcd_G(i*3, 3, &ucs[0]);					// f[^\iOTԖڂ܂Łj
				}else{
					disp_lcd_G((i-6)*3, 4, &ucs[0]);				// f[^\iUŌ܂Łj
				}
			}
			wait_all_sw_off();										//	SXCb`nee܂ő҂
			sw = 0;
		}

	}
}



//*******************************************************
//		M
//*******************************************************
void	ir_transmit_main(void)
{
	unsigned char	r;

	disp_clear_lcd_G();						// Clear Display

	ucs[0]  = 'T';
	ucs[1]  = 'R';
	ucs[2]  = 'N';
	ucs[3]  = 'S';
	ucs[4]  = 'M';
	ucs[5]  = 'I';
	ucs[6]  = 'T';
	ucs[7]  = 0x00;
	disp_lcd_G_10x16(0, 0, &ucs[0]);		// "TRANSMIT" \

	wait_all_sw_off();						//	SXCb`nee܂ő҂

	ir_trans_mode();						// M̑M[h

}
