//*****************************************
//@@PIC 16F1847 ir transciever Program
//  file name: lcd.c
//
//@kbc͂PQWSWhbgOtBbNW[gp
//    AQM1248A-RN
//
//@ȉkbcɕKvȐMꗗ
//
//@@@RB5:GLCD-RST*
//@@@RA7:GLCD-RS
//@@@RB2:GLCD-CS*
//@@@RA6:GLCD-SDA
//@@@RA4:GLCD-SCLK
//
//
//   MPLAB IDE v8.84  HiTEC C
//
//  2014/02/25  New(TAB4)  Taishi
//  2014/04/30  Modify for 16F1827  Taishi
//  2015/05/09  modify for 16F1847  Taishi
//  2021/09/05  modify for 16F1847 (ir transciever) Taishi
//*****************************************
#include	<htc.h>

#include	"ir_transciever.h"

#include	"pfont5x7.h"
#include	"lcd.h"


unsigned char	ucs[22];										// kbc\p鏊

// ******** MACRO ********
#define	rst_on()				(RB5 = 0)						// Reset* Sig:Low
#define	rst_off()				(RB5 = 1)						// Reset* Sig:High
#define	select_instruction()	(RA7 = 0)						// RS(D/I*) Sig:Low
#define	select_data()			(RA7 = 1)						// RS(D/I*) Sig:High
#define	cs_on()					(RB2 = 0)						// CS Sig:Low
#define	cs_off()				(RB2 = 1)						// CS Sig:Hogh
#define	sclk_h()				(RB4 = 1)						// SCLK:High
#define	sclk_l()				(RB4 = 0)						// SCLK:Low
#define	sda_h()					(RA6 = 1)						// SDA:High
#define	sda_l()					(RA6 = 0)						// SDA:Low

// ************************************* Graphic LCD Accese *********************
static	unsigned char	c_data[3][15];


//#ifdef deb_disp
//******************************
// Get Character Bit Data
// 5x7 Font
//  Get Data Save to c_data[0][5];
//******************************
static void	get_asc_data(unsigned char uc)
{
 #ifdef	NUMBER_ONLY							// ƁD(dot)ƁF(colon)Ɓ^(slash)g

	if(uc == ' '){							// Xy[X̃tHgʒu
		uc = 0;
	}else if((uc < '.')||(':' < uc)){		// ƁD(dot)ƁF(colon)Ɓ^(slash) ȊO̎
		uc = 1;								// D(dot)̃tHgʒu
	}else{
		uc = uc - '.' + 1;					// D(dot)̃tHgʒuɂ
	}

	uc *= 5;
	c_data[0][0] = font5x7[uc + 0];
	c_data[0][1] = font5x7[uc + 1];
	c_data[0][2] = font5x7[uc + 2];
	c_data[0][3] = font5x7[uc + 3];
	c_data[0][4] = font5x7[uc + 4];

 #else
	unsigned short	us;

	us = uc;

	c_data[0][0] = font5x7[us * 5 + 0];
	c_data[0][1] = font5x7[us * 5 + 1];
	c_data[0][2] = font5x7[us * 5 + 2];
	c_data[0][3] = font5x7[us * 5 + 3];
	c_data[0][4] = font5x7[us * 5 + 4];
 #endif
}
//#endif

//******************************
// LCD Bit Data Output
//  uc : Output Data(D0 -- D7)
//
//  \ qrAbr̓ZbgKvL
// *****************************
static void	lcd_G_bitdata_out(unsigned char uc)
{
	unsigned char	i;

	for(i=0x80;i != 0;i >>= 1){				// 8Bit Output
		if((uc & i)==0){					// Out Bit:0(ZERO)
			sda_l();						// SDA:Low
		}else{
			sda_h();						// SDA:High
		}
		sclk_l();							// SCLK:Low
		sclk_h();							// SCLK:High
	}
}
//******************************
// LCD Data Output
//  uc : Output Data(D0 -- D7)
//  rs : RS bit Data(0=Command, 1=Data)
//
// *****************************
static void	lcd_G_one_out(unsigned char uc, int rs)
{
	cs_on();								// CS:ON

	if(rs == 0){							// RS:0(Command)
		select_instruction();				// D/I* Sig:Low
	}else{									// RS:1(Data)
		select_data();						// D/I* Sig:High
	}

	lcd_G_bitdata_out(uc);					// 8Bit Output

	cs_off();								// CS:OFF
}
//******************************
// LCD Command Output
//  uc : Command Data(D0 -- D7)
// *****************************
static	void	lcd_G_cmd_out(unsigned char uc)
{
	lcd_G_one_out(uc, 0);
}
//******************************
// LCD Data Output
//  uc : Data(D0 -- D7)
// *****************************
static	void	lcd_G_data_out(unsigned char uc)
{
	lcd_G_one_out(uc, 1);
}
//******************************
// Init. LCD
//  \߁@gprbg͏o͕ɐݒ肵ėL鎖
// *****************************
void	init_lcd_G(void)
{
	cs_off();																	// CS:OFF
	sclk_h();																	// SCLK:High

	rst_on();																	// Reset* Sig:Low
	wait_ms(100);																// Wait 100ms
	rst_off();																	// Reset* Sig:High

	wait_ms(100);																// Wait 100ms

	lcd_G_cmd_out(0xAE);														// Display OFF

// ---------------------------------
#ifdef	UP_SIDE_DOWN
// \㉺t̎͂炪
	lcd_G_cmd_out(0xA1);
	lcd_G_cmd_out(0xC0);
#else	//UP_SIDE_DOWN
// \ʂ̎͂炪
	lcd_G_cmd_out(0xA0);														// ADC Normal
	lcd_G_cmd_out(0xC8);														// Common Output:revers
#endif	//UP_SIDE_DOWN
// ---------------------------------

	lcd_G_cmd_out(0xA3);														// bias:1/7

	// Internal Regulator ON
	lcd_G_cmd_out(0x2C);														// Power Control 1
	wait_ms(1);																	// Wait 1ms
	lcd_G_cmd_out(0x2E);														// Power Control 2
	wait_ms(1);																	// Wait 1ms
	lcd_G_cmd_out(0x2F);														// Power Control 3
	wait_ms(1);																	// Wait 1ms

	// Contrast
	lcd_G_cmd_out(0x23);														// Vo Voltage Resistor Ratio set
//	lcd_G_cmd_out(0x27);														// Vo Voltage Resistor Ratio set
	lcd_G_cmd_out(0x81);														// Electrpnic Volume Mode set
	lcd_G_cmd_out(0x1C);														// Electrpnic Volume Value set
//	lcd_G_cmd_out(0x3f);														// Electrpnic Volume Value set

	// Display
	lcd_G_cmd_out(0xA4);														// Display All Ponts:normal
	lcd_G_cmd_out(0x40);														// Display Start Line:0(ZERO)

#ifdef		REVERSE
	// Ŝ𔒍]\鎞inɔj
	lcd_G_cmd_out(0xA7);														// Display Nomal/Revers:reverse
#else
	// Ŝ𔒍\鎞inɍj
	lcd_G_cmd_out(0xA6);														// Display Nomal/Revers:nomal
#endif

	disp_clear_lcd_G();

	lcd_G_cmd_out(0xAF);														// Display ON

}
//******************************
// Clear Display
// *****************************
void	disp_clear_lcd_G(void)
{
	unsigned char	x;
	unsigned char	y;


	for(y=0;y < 8;y++){
		lcd_G_cmd_out((0xb0 | y));	// Page Set
		lcd_G_cmd_out(0x10);		// Column High Address Set

// ---------------------------------
#ifdef	UP_SIDE_DOWN
// \㉺t̎͂炪
	lcd_G_cmd_out(0x04);		// Column Low Address Set
#else	//UP_SIDE_DOWN
// \ʂ̎͂炪
	lcd_G_cmd_out(0x00);		// Column Low Address Set
#endif	//UP_SIDE_DOWN
// ---------------------------------

		for(x=0;x <128; x++){
			lcd_G_data_out(0x00);
		}
	}
}
//******************************
// One Line Clear Display
//   y: line number(0--7)
// *****************************
void	disp_line_clear_lcd_G(unsigned char y)
{
	unsigned char	x;

	lcd_G_cmd_out((0xb0 | y));	// Page Set
	lcd_G_cmd_out(0x10);		// Column High Address Set

// ---------------------------------
#ifdef	UP_SIDE_DOWN
// \㉺t̎͂炪
	lcd_G_cmd_out(0x04);		// Column Low Address Set
#else	//UP_SIDE_DOWN
// \ʂ̎͂炪
	lcd_G_cmd_out(0x00);		// Column Low Address Set
#endif	//UP_SIDE_DOWN
// ---------------------------------

	for(x=0;x <128; x++){
		lcd_G_data_out(0x00);
	}
}

//******************************
// display LCD One charcter
//  pos_x : Position X(0 -- 20)
//  pos_y : Position Y(0 -- 7)
//  uc : Charcter
//    E\sb`͂UhbgitHgԂPhbgLj
// *****************************
void	disp_one_char_lcd_G(unsigned char pos_x, unsigned char pos_y, unsigned char uc)
{
	pos_x *= 6;

// ---------------------------------
#ifdef	UP_SIDE_DOWN
// \㉺t̎͂炪
	pos_x += 4;
#else	//UP_SIDE_DOWN
// \ʂ̎͂炪
#endif	//UP_SIDE_DOWN
// ---------------------------------

	get_asc_data(uc);						// Get Character Bit Data
	lcd_G_cmd_out((0xb0 | pos_y));			// Page Set
	lcd_G_cmd_out(0x10 | (pos_x >> 4));		// Column High Address Set
	lcd_G_cmd_out(pos_x & 0x0f);			// Column Low Address Set
	lcd_G_data_out(c_data[0][0]);
	lcd_G_data_out(c_data[0][1]);
	lcd_G_data_out(c_data[0][2]);
	lcd_G_data_out(c_data[0][3]);
	lcd_G_data_out(c_data[0][4]);
	lcd_G_data_out(0x00);
}

//******************************
// display LCD One charcteri]\j
//  pos_x : Position X(0 -- 20)
//  pos_y : Position Y(0 -- 7)
//  uc : Charcter
//    E\sb`͂UhbgitHgԂPhbgLj
//    Iɔ]\鎞Ɏg
// *****************************
void	disp_one_char_lcd_G_reverse(unsigned char pos_x, unsigned char pos_y, unsigned char uc)
{
	pos_x *= 6;

// ---------------------------------
#ifdef	UP_SIDE_DOWN
// \㉺t̎͂炪
	pos_x += 4;
#else	//UP_SIDE_DOWN
// \ʂ̎͂炪
#endif	//UP_SIDE_DOWN
// ---------------------------------

	get_asc_data(uc);						// Get Character Bit Data
	lcd_G_cmd_out((0xb0 | pos_y));			// Page Set
	lcd_G_cmd_out(0x10 | (pos_x >> 4));		// Column High Address Set
	lcd_G_cmd_out(pos_x & 0x0f);			// Column Low Address Set
	lcd_G_data_out(c_data[0][0] ^ 0xff);
	lcd_G_data_out(c_data[0][1] ^ 0xff);
	lcd_G_data_out(c_data[0][2] ^ 0xff);
	lcd_G_data_out(c_data[0][3] ^ 0xff);
	lcd_G_data_out(c_data[0][4] ^ 0xff);
	lcd_G_data_out(0xff);
}


//******************************
// display LCD(20char x 8Line)
//  pos_x : Position X(0 -- 20)
//  pos_y : Position Y(0 -- 7,\̂ 0 -- 5)
//  ucp : String(termnate 0x00)
// *****************************
void	disp_lcd_G(unsigned char pos_x, unsigned char pos_y, unsigned char *ucp)
{
	unsigned char	pos;

	pos = pos_x;
	while(*ucp != 0x00){				// String Data Out
		if(20 < pos){
			break;
		}
		disp_one_char_lcd_G(pos, pos_y, *ucp);
		ucp++;
		pos++;
	}
}

// TVtHgPOPUɊĝׂQhbg̃f[^
const	unsigned char bt_07_10x16[8][2]={						// 5x7  10x16 ɑ傫鎞Ɏg
									{0b00000011, 0b00000000},	// D0
									{0b00001100, 0b00000000},	// D1
									{0b00110000, 0b00000000},	// D2
									{0b11000000, 0b00000000},	// D3
									{0b00000000, 0b00000011},	// D4
									{0b00000000, 0b00001100},	// D5
									{0b00000000, 0b00110000},	// D6
									{0b00000000, 0b11000000},	// D7
								};
//******************************
// Get Character Bit Data
// 10x16 Font
//  Get Data Save to c_data[3][15];
//******************************
static void	get_asc_data_10x16(unsigned char uc)
{
	unsigned short	us;
	unsigned char	ucd;
	unsigned char	i;
	unsigned char	j;
	unsigned char	k;
	unsigned char	bt;

#ifdef	NUMBER_ONLY							// ƁD(dot)ƁF(colon)Ɓ^(slash)g

	if(uc == ' '){							// Xy[X̃tHgʒu
		uc = 0;
	}else if((uc < '.')||(':' < uc)){		// ƁD(dot)ƁF(colon)Ɓ^(slash) ȊO̎
		uc = 1;								// D(dot)̃tHgʒu
	}else{
		uc = uc - '.' + 1;					// D(dot)̃tHgʒuɂ
	}
#else
#endif

	us = uc;
	us *= 5;

	for(i=0;i<10;i++){						// tHg鏊NA
		for(j=0;j<2;j++){
			c_data[j][i] = 0;
		}
	}

	for(i=0;i<5;i++){						// 5x7 tHg擾郋[v
		ucd = font5x7[us + i];
		for(bt=0x01,k=0;k<8;k++, bt<<= 1){		// 擾Wrbg̃f[^郋[v
			if((ucd & bt)!=0){
				for(j=0;j<2;j++){			// 5x7 ̂Prbg̃f[^2x2 ̃f[^ɂ郋[vi͂PỎj
					c_data[0][i*2+j] |= bt_07_10x16[k][0];
					c_data[1][i*2+j] |= bt_07_10x16[k][1];
				}
			}
		}
	}

}
//******************************
// display LCD One charcter 10x16 Font
//  pos_x : Position X(0 -- 9)
//  pos_y : Position Y(0 -- 2)
//  uc : Charcter
//    E\sb`͂PQbgitHgԂQhbgLj
// *****************************
void	disp_one_char_lcd_G_10x16(unsigned char pos_x, unsigned char pos_y, unsigned char uc)
{
	unsigned char	i;

	pos_x *= 12;

// ---------------------------------
#ifdef	UP_SIDE_DOWN
// \㉺t̎͂炪
	pos_x += 4;
#else	//UP_SIDE_DOWN
// \ʂ̎͂炪
#endif	//UP_SIDE_DOWN
// ---------------------------------

	pos_y *= 2;
	get_asc_data_10x16(uc);						// Get Character Bit Data

	for(i=0;i<2;i++){
		lcd_G_cmd_out(0xb0 | (pos_y+i));		// Page Set
		lcd_G_cmd_out(0x10 | (pos_x >> 4));		// Column High Address Set
		lcd_G_cmd_out(pos_x & 0x0f);			// Column Low Address Set
		lcd_G_data_out(c_data[i][0]);
		lcd_G_data_out(c_data[i][1]);
		lcd_G_data_out(c_data[i][2]);
		lcd_G_data_out(c_data[i][3]);
		lcd_G_data_out(c_data[i][4]);
		lcd_G_data_out(c_data[i][5]);
		lcd_G_data_out(c_data[i][6]);
		lcd_G_data_out(c_data[i][7]);
		lcd_G_data_out(c_data[i][8]);
		lcd_G_data_out(c_data[i][9]);

	}
//	lcd_G_data_out(0x00);
}
//******************************
// display LCD 10x16 Font (10char x 3Line)
//  pos_x : Position X(0 -- 9)
//  pos_y : Position Y(0 -- 2)
//  ucp : String(termnate 0x00)
// *****************************
void	disp_lcd_G_10x16(unsigned char pos_x, unsigned char pos_y, unsigned char *ucp)
{
	unsigned char	pos;

	if(pos_y <= 2){
		pos = pos_x;
		while(*ucp != 0x00){				// String Data Out
			if(9 < pos){
				break;
			}
			disp_one_char_lcd_G_10x16(pos, pos_y, *ucp);
			ucp++;
			pos++;
		}
	}
}


// TVtHgPTQSɊĝׂRhbg̃f[^
const	unsigned char bt_07_15x24[8][3]={											// 5x7  15x24 ɑ傫鎞Ɏg
									{0b00000111, 0b00000000, 0b00000000},	// D0
									{0b00111000, 0b00000000, 0b00000000},	// D1
									{0b11000000, 0b00000001, 0b00000000},	// D2
									{0b00000000, 0b00001110, 0b00000000},	// D3
									{0b00000000, 0b01110000, 0b00000000},	// D4
									{0b00000000, 0b10000000, 0b00000011},	// D5
									{0b00000000, 0b00000000, 0b00011100},	// D6
									{0b00000000, 0b00000000, 0b11100000},	// D7
								};
//******************************
// Get Character Bit Data
// 15x24 Font
//  Get Data Save to c_data[3][15];
//******************************
static void	get_asc_data_15x24(unsigned char uc)
{
	unsigned short	us;
	unsigned char	ucd;
	unsigned char	i;
	unsigned char	j;
	unsigned char	k;
	unsigned char	bt;

#ifdef	NUMBER_ONLY							// ƁD(dot)ƁF(colon)Ɓ^(slash)g

	if(uc == ' '){							// Xy[X̃tHgʒu
		uc = 0;
	}else if((uc < '.')||(':' < uc)){		// ƁD(dot)ƁF(colon)Ɓ^(slash) ȊO̎
		uc = 1;								// D(dot)̃tHgʒu
	}else{
		uc = uc - '.' + 1;					// D(dot)̃tHgʒuɂ
	}
#else
#endif

	us = uc;
	us *= 5;

	for(i=0;i<15;i++){						// tHg鏊NA
		for(j=0;j<3;j++){
			c_data[j][i] = 0;
		}
	}

	for(i=0;i<5;i++){						// 5x7 tHg擾郋[v
		ucd = font5x7[us + i];
		for(bt=0x01,k=0;k<8;k++, bt<<= 1){		// 擾Wrbg̃f[^郋[v
			if((ucd & bt)!=0){
				for(j=0;j<3;j++){			// 5x7 ̂Prbg̃f[^3x3 ̃f[^ɂ郋[vi͂PT̉j
					c_data[0][i*3+j] |= bt_07_15x24[k][0];
					c_data[1][i*3+j] |= bt_07_15x24[k][1];
					c_data[2][i*3+j] |= bt_07_15x24[k][2];
				}
			}
		}
	}

}
//******************************
// display LCD One charcter 15x24 Font
//  pos_x : Position X(0 -- 6)
//  pos_y : Position Y(0 -- 1)
//  uc : Charcter
//    E\sb`͂PWhbgitHgԂRhbgLj
// *****************************
void	disp_one_char_lcd_G_15x24(unsigned char pos_x, unsigned char pos_y, unsigned char uc)
{
	unsigned char	i;

	pos_x *= 18;

// ---------------------------------
#ifdef	UP_SIDE_DOWN
// \㉺t̎͂炪
	pos_x += 4;
#else	//UP_SIDE_DOWN
// \ʂ̎͂炪
#endif	//UP_SIDE_DOWN
// ---------------------------------

	pos_y *= 3;
	get_asc_data_15x24(uc);						// Get Character Bit Data

	for(i=0;i<3;i++){
		lcd_G_cmd_out(0xb0 | (pos_y+i));		// Page Set
		lcd_G_cmd_out(0x10 | (pos_x >> 4));		// Column High Address Set
		lcd_G_cmd_out(pos_x & 0x0f);			// Column Low Address Set
		lcd_G_data_out(c_data[i][0]);
		lcd_G_data_out(c_data[i][1]);
		lcd_G_data_out(c_data[i][2]);
		lcd_G_data_out(c_data[i][3]);
		lcd_G_data_out(c_data[i][4]);
		lcd_G_data_out(c_data[i][5]);
		lcd_G_data_out(c_data[i][6]);
		lcd_G_data_out(c_data[i][7]);
		lcd_G_data_out(c_data[i][8]);
		lcd_G_data_out(c_data[i][9]);
		lcd_G_data_out(c_data[i][10]);
		lcd_G_data_out(c_data[i][11]);
		lcd_G_data_out(c_data[i][12]);
		lcd_G_data_out(c_data[i][13]);
		lcd_G_data_out(c_data[i][14]);
	}
//	lcd_G_data_out(0x00);
}
//******************************
// display LCD 15x24 Font (8char x 2Line)
//  pos_x : Position X(0 -- 6)
//  pos_y : Position Y(0 -- 1)
//  ucp : String(termnate 0x00)
// *****************************
void	disp_lcd_G_15x24(unsigned char pos_x, unsigned char pos_y, unsigned char *ucp)
{
	unsigned char	pos;

	if(pos_y <= 1){
		pos = pos_x;
		while(*ucp != 0x00){				// String Data Out
			if(6 < pos){
				break;
			}
			disp_one_char_lcd_G_15x24(pos, pos_y, *ucp);
			ucp++;
			pos++;
		}
	}
}

//******************************
// display LCD(20char x 8Line, ]\)
//  pos_x : Position X(0 -- 20)
//  pos_y : Position Y(0 -- 7,\̂ 0 -- 5)
//  ucp : String(termnate 0x00)
//  Iɔ]\鎞Ɏg
// *****************************
void	disp_lcd_G_reverse(unsigned char pos_x, unsigned char pos_y, unsigned char *ucp)
{
	unsigned char	pos;

	pos = pos_x;
	while(*ucp != 0x00){				// String Data Out
		if(20 < pos){
			break;
		}
		disp_one_char_lcd_G_reverse(pos, pos_y, *ucp);
		ucp++;
		pos++;
	}
}


#if	0
//******************************
// display Font LCD(15x24dot,7char x 2Line)
//  ̕\
//   gRTC_min(BCD) ɗL
//  Qsځijɕ\
// *****************************
void	disp_lcd_G_MIN_15x24(void)
{
	gUcd[0] = ((gRTC_min >> 4)&0x07)+'0';
	gUcd[1] = (gRTC_min & 0x0f)+'0';
	gUcd[2] = 0x00;
	disp_lcd_G_15x24(4, 1, gUcd);
}
//******************************
// display Font LCD(15x24dot,7char x 2Line)
//  ̕\
//   gRTC_hou(BCD) ɗL
//  Qsځijɕ\
// *****************************
void	disp_lcd_G_HOU_15x24(void)
{
	gUcd[0] = ((gRTC_hou >> 4)&0x03)+'0';	// \
	gUcd[1] = (gRTC_hou & 0x0f)+'0';
	gUcd[2] = 0x00;
	disp_lcd_G_15x24(1, 1, gUcd);
}
//******************************
// display Font LCD(10x16dot,10char x 3Line)
//  ̕\
//   gRTC_min(BCD) ɗL
//  Psځiԏ㑤jɕ\
// *****************************
void	disp_lcd_G_DAY_10x16(void)
{
	gUcd[0] = ((gRTC_day >> 4)&0x03)+'0';
	gUcd[1] = (gRTC_day & 0x0f)+'0';
	gUcd[2] = 0x00;
	disp_lcd_G_10x16(8, 0, gUcd);
}
//******************************
// display Font LCD(10x16dot,10char x 3Line)
//  ̕\
//   gRTC_hou(BCD) ɗL
//  Psځiԏ㑤jɕ\
// *****************************
void	disp_lcd_G_MON_10x16(void)
{
	gUcd[0] = ((gRTC_mon >> 4)&0x01)+'0';
	gUcd[1] = (gRTC_mon & 0x0f)+'0';
	gUcd[2] = 0x00;
	disp_lcd_G_10x16(5, 0, gUcd);
}
//******************************
// display Font LCD(10x16dot,10char x 3Line)
//  N̕\
//  N gRTC_year(BCD) ɗL
//  Psځiԏ㑤jɕ\
// *****************************
void	disp_lcd_G_YEAR_10x16(void)
{
	gUcd[0] = (gRTC_year >> 4)+'0';
	gUcd[1] = (gRTC_year & 0x0f)+'0';
	gUcd[2] = 0x00;
	disp_lcd_G_10x16(2, 0, gUcd);
}
//******************************
// display Font LCD(10x16dot,10char x 3Line)
//  NAA̕\
//  N gRTC_year(BCD) ɗL
//   gRTC_hou(BCD) ɗL
//   gRTC_min(BCD) ɗL
//   gRTC_hou(BCD) ɗL
//   gRTC_min(BCD) ɗL
//******************************
void	disp_lcd_G_YMDHM_10x16(void)
{
	disp_lcd_G_YEAR_10x16();		//  N̕\
	disp_lcd_G_MON_10x16();			//  ̕\
	disp_lcd_G_DAY_10x16();			//  ̕\
	disp_lcd_G_HOU_15x24();			//  ̕\
	disp_lcd_G_MIN_15x24();			//  ̕\
}
//******************************
// display Font LCD(10x16dot,10char x 3Line)
//  NAǍŒ蕔\
//@RAN̂QOAXbV
//******************************
void	disp_lcd_G_YMDHM_FIX_10x16(void)
{
	disp_one_char_lcd_G_15x24(3, 1, ':');	// R
	disp_one_char_lcd_G_10x16(0, 0, '2');	// ŃfQf
	disp_one_char_lcd_G_10x16(1, 0, '0');	// ŃfOf
	disp_one_char_lcd_G_10x16(7, 0, '/');	// XbV
}
#endif

#ifdef	HARD3_LCD_DISP
// tHg`FbN\ikbc̃n[h`FbNj
//******************************
// display Font LCD(21char x 6Line)
//  Code 0 --> 120
// *****************************
void	disp_lcd_G_font_check1(void)
{
	unsigned char	x;
	unsigned char	y;
	unsigned char	uc;

	disp_clear_lcd_G();
	uc = 0;
	for(y=0;y<6;y++){
		for(x=0;x<21;x++){
			disp_one_char_lcd_G(x, y, uc);
			uc++;
		}
	}
}



//******************************
// display Font LCD(21char x 6Line)
//  Code 121 --> 241
// *****************************
void	disp_lcd_G_font_check2(void)
{
	unsigned char	x;
	unsigned char	y;
	unsigned char	uc;

	disp_clear_lcd_G();
	uc = 121;
	for(y=0;y<6;y++){
		for(x=0;x<21;x++){
			disp_one_char_lcd_G(x, y, uc);
			uc++;
		}
	}
}



//******************************
// display Font LCD(20char x 6Line)
//  Code 242 --> 255
// *****************************
void	disp_lcd_G_font_check3(void)
{
	unsigned char	x;
	unsigned char	y;
	unsigned char	uc;

	disp_clear_lcd_G();
	uc = 240;
	for(y=0;y<1;y++){
		for(x=0;x<14;x++){
			disp_one_char_lcd_G(x, y, uc);
			uc++;
		}
	}
}
#endif


//******************************
// display Font LCD(7char x 2Line)
//  0x20, '.' --> ':'
// *****************************
void	disp_lcd_G_font_check_15x24(void)
{
	unsigned char	x;
	unsigned char	y;
	unsigned char	uc;

	disp_clear_lcd_G();
	uc = ' ';
	for(y=0;y<2;y++){
		for(x=0;x<7;x++){
			disp_one_char_lcd_G_15x24(x, y, uc);
			if(uc == ' '){
				uc = '.';
			}else{
				uc++;
			}
		}
	}
}

